// Alternating bit protocol, channel with message loss

mtype {MSG, ACK};
chan RtoS = [2] of {mtype, bit};
chan StoR = [2] of {mtype, bit};

active proctype Sender()
{
    bit sendbit, ackbit;
    do
    ::  if 
        :: StoR ! MSG, sendbit
        :: skip  /* MSG lost */
        fi
        if 
        :: RtoS ? ACK, ackbit ->
            if
            :: ackbit == sendbit ->
               sendbit = 1-sendbit
            :: else -> skip
            fi
        :: timeout -> skip
        fi
    od
}

active proctype Receiver()
{
    bit recvbit;
    do
    :: StoR ? MSG, recvbit ->
        RtoS ! ACK, recvbit
    :: StoR ? MSG, recvbit ->
        skip          /* ACK lost */
    :: timeout -> 
        RtoS ! ACK, recvbit
    od
}
